import os
import sys
import md5
import string
import popen2
import random

def DiskFreeSpaceKB(path,df="df",quiet=0):
	command = df + " " + path
	output = os.popen(command).read()
	for line in string.split(output,"\n"):
		if string.find(line,"Filesystem") >= 0: continue #skip header
		fields = string.split(line)
		try:
			free_space = long(fields[3])
		except:
			if string.find(df,"-P") < 0:
				#Try using gnu df posix output format
				free_space = DiskFreeSpaceKB(path,df=df + " -P",quiet=1)
				if free_space <> None: return free_space
			if quiet: return None
			sys.stderr.write("Failed to parse output of " + df + ":\n" + line)
			raise
		return free_space

def DirectoryTreeSizeKB(path):
	command = "du -s " + path
	du = os.popen(command).read()
	for line in string.split(du,"\n"):
		fields = string.split(line)
		try:
			used_space = long(fields[0])
		except:
			sys.stderr.write("Failed to parse output of du:\n" + line)
			raise
		return used_space

def MemorySizeKB():
	p = popen2.Popen3("free | awk '/^Mem/ {print $2}'")
	output = p.fromchild.read()
	p.wait()
	return long(output)

def MemoryFreeKB():
	p = popen2.Popen3("free | awk '/^Mem/ {print $4}'")
	output = p.fromchild.read()
	p.wait()
	return long(output)

def BinToHexDigest(d):
	hd = ""
	for ch in d[0:]:
		hd = hd + ("%02x" % ord(ch))
	return hd

def FileMD5(path):
	m = md5.new()
	f = open(path)
	while 1:
		data = f.read(1024)
		if not data: break
		m.update(data)
	f.close()
	#The digest is binary data (possibly containing null bytes).
	#Convert it to standard hexidecimal form:
	#The following works in python 2.2
	#return m.hexdigest()
	return BinToHexDigest(m.digest())

def FileSize(path):
	try:
		return os.stat(path)[6]
	except OSError, e:
		if e.errno == 2:
			return None
		raise

def CreateTestFile(fname,size):
	existing_size = FileSize(fname)
	if existing_size <> None and existing_size/1024 == size/1024:
		return

	buf = ""
	count = 0
	while count < 1024:
		count = count + 1
		buf = buf + ("%c" % random.randint(0,255))

	F = open(fname,"w")

	blocks = size/1024

	block = blocks
	while block > 0:
		block = block - 1
		F.write(buf)

	F.close()

#The definition of shuffle() is taken from python2.2 random.py
def shuffle(x):
	"""x, random=random.random -> shuffle list x in place; return None."""

	for i in xrange(len(x)-1, 0, -1):
		# pick an element in x[:i+1] with which to exchange x[i]
		j = int(random.random() * (i+1))
		x[i], x[j] = x[j], x[i]

rand_chars = """abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ !@#$%^&*()-+_=01234567890[]{};\':\",.<>/?`~\\|"""

def RandomLine():
	buf = ""
	count = 0
	linelen=random.randint(20,100)
	while count < linelen:
		count = count + 1
		buf = buf + random.choice(rand_chars)
	buf = buf + "\n"
	return buf

def CreateTestTextFile(fname,size):
	existing_size = FileSize(fname)
	if existing_size <> None and existing_size/1024 == size/1024:
		return

	F = open(fname,"w")

	lines = []
	for i in range(0,512):
		buf = ""
		#Roll some lines together to speed up shuffle
		#As long as len(buf)<1024, this is fine.
		for j in range(0,5):
			buf = buf + RandomLine()
		lines.append(buf)

	s = 0
	while s < size:
		for i in range(0,len(lines)):
			buf = lines[i]
			F.write(buf)
			s = s + len(buf)
			if s >= size: break
		shuffle(lines)

	F.close()
